package de.hawhamburg.lifecycle.agent;

import de.hawhamburg.lifecycle.data.JsonInfoMessage;
/**
 * Methods to interact with the life cycle framework.
 * @author Jens Ellenberg, Jan Menzel
 *
 */
public interface LifeCycleAgent {

    /**
     * the application no longer communicates with the Blackboard.
     */
    void sleep();

    /**
     * Generating a Info Message.
     *
     * @return The info message as {@link JsonInfoMessage}.
     */
    JsonInfoMessage getInfoMessage();

    /**
     * start with the actual work.
     */
    void start();

    /**
     * shutting the agent down.
     */
    void stop();

    /**
     * the identifier of the Application.
     *
     * @return The ID as {@link String}.
     */
    String getID();
}
